git-rebase--interactive.shon commit Merge branch 'pc/remove-warn' into maint (21919d3)
   1#!/bin/sh
   2#
   3# Copyright (c) 2006 Johannes E. Schindelin
   4
   5# SHORT DESCRIPTION
   6#
   7# This script makes it easy to fix up commits in the middle of a series,
   8# and rearrange commits.
   9#
  10# The original idea comes from Eric W. Biederman, in
  11# http://article.gmane.org/gmane.comp.version-control.git/22407
  12
  13OPTIONS_KEEPDASHDASH=
  14OPTIONS_SPEC="\
  15git-rebase [-i] [options] [--] <upstream> [<branch>]
  16git-rebase [-i] (--continue | --abort | --skip)
  17--
  18 Available options are
  19v,verbose          display a diffstat of what changed upstream
  20onto=              rebase onto given branch instead of upstream
  21p,preserve-merges  try to recreate merges instead of ignoring them
  22s,strategy=        use the given merge strategy
  23no-ff              cherry-pick all commits, even if unchanged
  24m,merge            always used (no-op)
  25i,interactive      always used (no-op)
  26 Actions:
  27continue           continue rebasing process
  28abort              abort rebasing process and restore original branch
  29skip               skip current patch and continue rebasing process
  30no-verify          override pre-rebase hook from stopping the operation
  31root               rebase all reachable commmits up to the root(s)
  32autosquash         move commits that begin with squash!/fixup! under -i
  33"
  34
  35. git-sh-setup
  36require_work_tree
  37
  38DOTEST="$GIT_DIR/rebase-merge"
  39
  40# The file containing rebase commands, comments, and empty lines.
  41# This file is created by "git rebase -i" then edited by the user.  As
  42# the lines are processed, they are removed from the front of this
  43# file and written to the tail of $DONE.
  44TODO="$DOTEST"/git-rebase-todo
  45
  46# The rebase command lines that have already been processed.  A line
  47# is moved here when it is first handled, before any associated user
  48# actions.
  49DONE="$DOTEST"/done
  50
  51# The commit message that is planned to be used for any changes that
  52# need to be committed following a user interaction.
  53MSG="$DOTEST"/message
  54
  55# The file into which is accumulated the suggested commit message for
  56# squash/fixup commands.  When the first of a series of squash/fixups
  57# is seen, the file is created and the commit message from the
  58# previous commit and from the first squash/fixup commit are written
  59# to it.  The commit message for each subsequent squash/fixup commit
  60# is appended to the file as it is processed.
  61#
  62# The first line of the file is of the form
  63#     # This is a combination of $COUNT commits.
  64# where $COUNT is the number of commits whose messages have been
  65# written to the file so far (including the initial "pick" commit).
  66# Each time that a commit message is processed, this line is read and
  67# updated.  It is deleted just before the combined commit is made.
  68SQUASH_MSG="$DOTEST"/message-squash
  69
  70# If the current series of squash/fixups has not yet included a squash
  71# command, then this file exists and holds the commit message of the
  72# original "pick" commit.  (If the series ends without a "squash"
  73# command, then this can be used as the commit message of the combined
  74# commit without opening the editor.)
  75FIXUP_MSG="$DOTEST"/message-fixup
  76
  77# $REWRITTEN is the name of a directory containing files for each
  78# commit that is reachable by at least one merge base of $HEAD and
  79# $UPSTREAM. They are not necessarily rewritten, but their children
  80# might be.  This ensures that commits on merged, but otherwise
  81# unrelated side branches are left alone. (Think "X" in the man page's
  82# example.)
  83REWRITTEN="$DOTEST"/rewritten
  84
  85DROPPED="$DOTEST"/dropped
  86
  87# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  88# GIT_AUTHOR_DATE that will be used for the commit that is currently
  89# being rebased.
  90AUTHOR_SCRIPT="$DOTEST"/author-script
  91
  92# When an "edit" rebase command is being processed, the SHA1 of the
  93# commit to be edited is recorded in this file.  When "git rebase
  94# --continue" is executed, if there are any staged changes then they
  95# will be amended to the HEAD commit, but only provided the HEAD
  96# commit is still the commit to be edited.  When any other rebase
  97# command is processed, this file is deleted.
  98AMEND="$DOTEST"/amend
  99
 100# For the post-rewrite hook, we make a list of rewritten commits and
 101# their new sha1s.  The rewritten-pending list keeps the sha1s of
 102# commits that have been processed, but not committed yet,
 103# e.g. because they are waiting for a 'squash' command.
 104REWRITTEN_LIST="$DOTEST"/rewritten-list
 105REWRITTEN_PENDING="$DOTEST"/rewritten-pending
 106
 107PRESERVE_MERGES=
 108STRATEGY=
 109ONTO=
 110VERBOSE=
 111OK_TO_SKIP_PRE_REBASE=
 112REBASE_ROOT=
 113AUTOSQUASH=
 114NEVER_FF=
 115
 116GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
 117mark the corrected paths with 'git add <paths>', and
 118run 'git rebase --continue'"
 119export GIT_CHERRY_PICK_HELP
 120
 121warn () {
 122        echo "$*" >&2
 123}
 124
 125output () {
 126        case "$VERBOSE" in
 127        '')
 128                output=$("$@" 2>&1 )
 129                status=$?
 130                test $status != 0 && printf "%s\n" "$output"
 131                return $status
 132                ;;
 133        *)
 134                "$@"
 135                ;;
 136        esac
 137}
 138
 139# Output the commit message for the specified commit.
 140commit_message () {
 141        git cat-file commit "$1" | sed "1,/^$/d"
 142}
 143
 144run_pre_rebase_hook () {
 145        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
 146           test -x "$GIT_DIR/hooks/pre-rebase"
 147        then
 148                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 149                        echo >&2 "The pre-rebase hook refused to rebase."
 150                        exit 1
 151                }
 152        fi
 153}
 154
 155require_clean_work_tree () {
 156        # test if working tree is dirty
 157        git rev-parse --verify HEAD > /dev/null &&
 158        git update-index --ignore-submodules --refresh &&
 159        git diff-files --quiet --ignore-submodules &&
 160        git diff-index --cached --quiet HEAD --ignore-submodules -- ||
 161        die "Working tree is dirty"
 162}
 163
 164ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
 165
 166comment_for_reflog () {
 167        case "$ORIG_REFLOG_ACTION" in
 168        ''|rebase*)
 169                GIT_REFLOG_ACTION="rebase -i ($1)"
 170                export GIT_REFLOG_ACTION
 171                ;;
 172        esac
 173}
 174
 175last_count=
 176mark_action_done () {
 177        sed -e 1q < "$TODO" >> "$DONE"
 178        sed -e 1d < "$TODO" >> "$TODO".new
 179        mv -f "$TODO".new "$TODO"
 180        count=$(sane_grep -c '^[^#]' < "$DONE")
 181        total=$(($count+$(sane_grep -c '^[^#]' < "$TODO")))
 182        if test "$last_count" != "$count"
 183        then
 184                last_count=$count
 185                printf "Rebasing (%d/%d)\r" $count $total
 186                test -z "$VERBOSE" || echo
 187        fi
 188}
 189
 190make_patch () {
 191        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 192        case "$sha1_and_parents" in
 193        ?*' '?*' '?*)
 194                git diff --cc $sha1_and_parents
 195                ;;
 196        ?*' '?*)
 197                git diff-tree -p "$1^!"
 198                ;;
 199        *)
 200                echo "Root commit"
 201                ;;
 202        esac > "$DOTEST"/patch
 203        test -f "$MSG" ||
 204                commit_message "$1" > "$MSG"
 205        test -f "$AUTHOR_SCRIPT" ||
 206                get_author_ident_from_commit "$1" > "$AUTHOR_SCRIPT"
 207}
 208
 209die_with_patch () {
 210        echo "$1" > "$DOTEST"/stopped-sha
 211        make_patch "$1"
 212        git rerere
 213        die "$2"
 214}
 215
 216die_abort () {
 217        rm -rf "$DOTEST"
 218        die "$1"
 219}
 220
 221has_action () {
 222        sane_grep '^[^#]' "$1" >/dev/null
 223}
 224
 225# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 226# GIT_AUTHOR_DATE exported from the current environment.
 227do_with_author () {
 228        (
 229                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 230                "$@"
 231        )
 232}
 233
 234pick_one () {
 235        ff=--ff
 236        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 237        case "$NEVER_FF" in '') ;; ?*) ff= ;; esac
 238        output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
 239        test -d "$REWRITTEN" &&
 240                pick_one_preserving_merges "$@" && return
 241        if test -n "$REBASE_ROOT"
 242        then
 243                output git cherry-pick "$@"
 244                return
 245        fi
 246        output git cherry-pick $ff "$@"
 247}
 248
 249pick_one_preserving_merges () {
 250        fast_forward=t
 251        case "$1" in
 252        -n)
 253                fast_forward=f
 254                sha1=$2
 255                ;;
 256        *)
 257                sha1=$1
 258                ;;
 259        esac
 260        sha1=$(git rev-parse $sha1)
 261
 262        if test -f "$DOTEST"/current-commit
 263        then
 264                if test "$fast_forward" = t
 265                then
 266                        cat "$DOTEST"/current-commit | while read current_commit
 267                        do
 268                                git rev-parse HEAD > "$REWRITTEN"/$current_commit
 269                        done
 270                        rm "$DOTEST"/current-commit ||
 271                        die "Cannot write current commit's replacement sha1"
 272                fi
 273        fi
 274
 275        echo $sha1 >> "$DOTEST"/current-commit
 276
 277        # rewrite parents; if none were rewritten, we can fast-forward.
 278        new_parents=
 279        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 280        if test "$pend" = " "
 281        then
 282                pend=" root"
 283        fi
 284        while [ "$pend" != "" ]
 285        do
 286                p=$(expr "$pend" : ' \([^ ]*\)')
 287                pend="${pend# $p}"
 288
 289                if test -f "$REWRITTEN"/$p
 290                then
 291                        new_p=$(cat "$REWRITTEN"/$p)
 292
 293                        # If the todo reordered commits, and our parent is marked for
 294                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 295                        # drop it on top of the current HEAD
 296                        if test -z "$new_p"
 297                        then
 298                                new_p=$(git rev-parse HEAD)
 299                        fi
 300
 301                        test $p != $new_p && fast_forward=f
 302                        case "$new_parents" in
 303                        *$new_p*)
 304                                ;; # do nothing; that parent is already there
 305                        *)
 306                                new_parents="$new_parents $new_p"
 307                                ;;
 308                        esac
 309                else
 310                        if test -f "$DROPPED"/$p
 311                        then
 312                                fast_forward=f
 313                                replacement="$(cat "$DROPPED"/$p)"
 314                                test -z "$replacement" && replacement=root
 315                                pend=" $replacement$pend"
 316                        else
 317                                new_parents="$new_parents $p"
 318                        fi
 319                fi
 320        done
 321        case $fast_forward in
 322        t)
 323                output warn "Fast-forward to $sha1"
 324                output git reset --hard $sha1 ||
 325                        die "Cannot fast-forward to $sha1"
 326                ;;
 327        f)
 328                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 329
 330                if [ "$1" != "-n" ]
 331                then
 332                        # detach HEAD to current parent
 333                        output git checkout $first_parent 2> /dev/null ||
 334                                die "Cannot move HEAD to $first_parent"
 335                fi
 336
 337                case "$new_parents" in
 338                ' '*' '*)
 339                        test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
 340
 341                        # redo merge
 342                        author_script=$(get_author_ident_from_commit $sha1)
 343                        eval "$author_script"
 344                        msg="$(commit_message $sha1)"
 345                        # No point in merging the first parent, that's HEAD
 346                        new_parents=${new_parents# $first_parent}
 347                        if ! do_with_author output \
 348                                git merge $STRATEGY -m "$msg" $new_parents
 349                        then
 350                                printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
 351                                die_with_patch $sha1 "Error redoing merge $sha1"
 352                        fi
 353                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$REWRITTEN_LIST"
 354                        ;;
 355                *)
 356                        output git cherry-pick "$@" ||
 357                                die_with_patch $sha1 "Could not pick $sha1"
 358                        ;;
 359                esac
 360                ;;
 361        esac
 362}
 363
 364nth_string () {
 365        case "$1" in
 366        *1[0-9]|*[04-9]) echo "$1"th;;
 367        *1) echo "$1"st;;
 368        *2) echo "$1"nd;;
 369        *3) echo "$1"rd;;
 370        esac
 371}
 372
 373update_squash_messages () {
 374        if test -f "$SQUASH_MSG"; then
 375                mv "$SQUASH_MSG" "$SQUASH_MSG".bak || exit
 376                COUNT=$(($(sed -n \
 377                        -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
 378                        -e "q" < "$SQUASH_MSG".bak)+1))
 379                {
 380                        echo "# This is a combination of $COUNT commits."
 381                        sed -e 1d -e '2,/^./{
 382                                /^$/d
 383                        }' <"$SQUASH_MSG".bak
 384                } >"$SQUASH_MSG"
 385        else
 386                commit_message HEAD > "$FIXUP_MSG" || die "Cannot write $FIXUP_MSG"
 387                COUNT=2
 388                {
 389                        echo "# This is a combination of 2 commits."
 390                        echo "# The first commit's message is:"
 391                        echo
 392                        cat "$FIXUP_MSG"
 393                } >"$SQUASH_MSG"
 394        fi
 395        case $1 in
 396        squash)
 397                rm -f "$FIXUP_MSG"
 398                echo
 399                echo "# This is the $(nth_string $COUNT) commit message:"
 400                echo
 401                commit_message $2
 402                ;;
 403        fixup)
 404                echo
 405                echo "# The $(nth_string $COUNT) commit message will be skipped:"
 406                echo
 407                commit_message $2 | sed -e 's/^/#       /'
 408                ;;
 409        esac >>"$SQUASH_MSG"
 410}
 411
 412peek_next_command () {
 413        sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$TODO"
 414}
 415
 416# A squash/fixup has failed.  Prepare the long version of the squash
 417# commit message, then die_with_patch.  This code path requires the
 418# user to edit the combined commit message for all commits that have
 419# been squashed/fixedup so far.  So also erase the old squash
 420# messages, effectively causing the combined commit to be used as the
 421# new basis for any further squash/fixups.  Args: sha1 rest
 422die_failed_squash() {
 423        mv "$SQUASH_MSG" "$MSG" || exit
 424        rm -f "$FIXUP_MSG"
 425        cp "$MSG" "$GIT_DIR"/MERGE_MSG || exit
 426        warn
 427        warn "Could not apply $1... $2"
 428        die_with_patch $1 ""
 429}
 430
 431flush_rewritten_pending() {
 432        test -s "$REWRITTEN_PENDING" || return
 433        newsha1="$(git rev-parse HEAD^0)"
 434        sed "s/$/ $newsha1/" < "$REWRITTEN_PENDING" >> "$REWRITTEN_LIST"
 435        rm -f "$REWRITTEN_PENDING"
 436}
 437
 438record_in_rewritten() {
 439        oldsha1="$(git rev-parse $1)"
 440        echo "$oldsha1" >> "$REWRITTEN_PENDING"
 441
 442        case "$(peek_next_command)" in
 443            squash|s|fixup|f)
 444                ;;
 445            *)
 446                flush_rewritten_pending
 447                ;;
 448        esac
 449}
 450
 451do_next () {
 452        rm -f "$MSG" "$AUTHOR_SCRIPT" "$AMEND" || exit
 453        read command sha1 rest < "$TODO"
 454        case "$command" in
 455        '#'*|''|noop)
 456                mark_action_done
 457                ;;
 458        pick|p)
 459                comment_for_reflog pick
 460
 461                mark_action_done
 462                pick_one $sha1 ||
 463                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 464                record_in_rewritten $sha1
 465                ;;
 466        reword|r)
 467                comment_for_reflog reword
 468
 469                mark_action_done
 470                pick_one $sha1 ||
 471                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 472                git commit --amend --no-post-rewrite
 473                record_in_rewritten $sha1
 474                ;;
 475        edit|e)
 476                comment_for_reflog edit
 477
 478                mark_action_done
 479                pick_one $sha1 ||
 480                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 481                echo "$sha1" > "$DOTEST"/stopped-sha
 482                make_patch $sha1
 483                git rev-parse --verify HEAD > "$AMEND"
 484                warn "Stopped at $sha1... $rest"
 485                warn "You can amend the commit now, with"
 486                warn
 487                warn "  git commit --amend"
 488                warn
 489                warn "Once you are satisfied with your changes, run"
 490                warn
 491                warn "  git rebase --continue"
 492                warn
 493                exit 0
 494                ;;
 495        squash|s|fixup|f)
 496                case "$command" in
 497                squash|s)
 498                        squash_style=squash
 499                        ;;
 500                fixup|f)
 501                        squash_style=fixup
 502                        ;;
 503                esac
 504                comment_for_reflog $squash_style
 505
 506                test -f "$DONE" && has_action "$DONE" ||
 507                        die "Cannot '$squash_style' without a previous commit"
 508
 509                mark_action_done
 510                update_squash_messages $squash_style $sha1
 511                author_script=$(get_author_ident_from_commit HEAD)
 512                echo "$author_script" > "$AUTHOR_SCRIPT"
 513                eval "$author_script"
 514                output git reset --soft HEAD^
 515                pick_one -n $sha1 || die_failed_squash $sha1 "$rest"
 516                case "$(peek_next_command)" in
 517                squash|s|fixup|f)
 518                        # This is an intermediate commit; its message will only be
 519                        # used in case of trouble.  So use the long version:
 520                        do_with_author output git commit --no-verify -F "$SQUASH_MSG" ||
 521                                die_failed_squash $sha1 "$rest"
 522                        ;;
 523                *)
 524                        # This is the final command of this squash/fixup group
 525                        if test -f "$FIXUP_MSG"
 526                        then
 527                                do_with_author git commit --no-verify -F "$FIXUP_MSG" ||
 528                                        die_failed_squash $sha1 "$rest"
 529                        else
 530                                cp "$SQUASH_MSG" "$GIT_DIR"/SQUASH_MSG || exit
 531                                rm -f "$GIT_DIR"/MERGE_MSG
 532                                do_with_author git commit --no-verify -e ||
 533                                        die_failed_squash $sha1 "$rest"
 534                        fi
 535                        rm -f "$SQUASH_MSG" "$FIXUP_MSG"
 536                        ;;
 537                esac
 538                record_in_rewritten $sha1
 539                ;;
 540        *)
 541                warn "Unknown command: $command $sha1 $rest"
 542                if git rev-parse --verify -q "$sha1" >/dev/null
 543                then
 544                        die_with_patch $sha1 "Please fix this in the file $TODO."
 545                else
 546                        die "Please fix this in the file $TODO."
 547                fi
 548                ;;
 549        esac
 550        test -s "$TODO" && return
 551
 552        comment_for_reflog finish &&
 553        HEADNAME=$(cat "$DOTEST"/head-name) &&
 554        OLDHEAD=$(cat "$DOTEST"/head) &&
 555        SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
 556        NEWHEAD=$(git rev-parse HEAD) &&
 557        case $HEADNAME in
 558        refs/*)
 559                message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
 560                git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
 561                git symbolic-ref HEAD $HEADNAME
 562                ;;
 563        esac && {
 564                test ! -f "$DOTEST"/verbose ||
 565                        git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
 566        } &&
 567        {
 568                test -s "$REWRITTEN_LIST" &&
 569                git notes copy --for-rewrite=rebase < "$REWRITTEN_LIST" ||
 570                true # we don't care if this copying failed
 571        } &&
 572        if test -x "$GIT_DIR"/hooks/post-rewrite &&
 573                test -s "$REWRITTEN_LIST"; then
 574                "$GIT_DIR"/hooks/post-rewrite rebase < "$REWRITTEN_LIST"
 575                true # we don't care if this hook failed
 576        fi &&
 577        rm -rf "$DOTEST" &&
 578        git gc --auto &&
 579        warn "Successfully rebased and updated $HEADNAME."
 580
 581        exit
 582}
 583
 584do_rest () {
 585        while :
 586        do
 587                do_next
 588        done
 589}
 590
 591# skip picking commits whose parents are unchanged
 592skip_unnecessary_picks () {
 593        fd=3
 594        while read command sha1 rest
 595        do
 596                # fd=3 means we skip the command
 597                case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
 598                3,pick,"$ONTO"*|3,p,"$ONTO"*)
 599                        # pick a commit whose parent is current $ONTO -> skip
 600                        ONTO=$sha1
 601                        ;;
 602                3,#*|3,,*)
 603                        # copy comments
 604                        ;;
 605                *)
 606                        fd=1
 607                        ;;
 608                esac
 609                echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
 610        done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
 611        mv -f "$TODO".new "$TODO" &&
 612        case "$(peek_next_command)" in
 613        squash|s|fixup|f)
 614                record_in_rewritten "$ONTO"
 615                ;;
 616        esac ||
 617        die "Could not skip unnecessary pick commands"
 618}
 619
 620# check if no other options are set
 621is_standalone () {
 622        test $# -eq 2 -a "$2" = '--' &&
 623        test -z "$ONTO" &&
 624        test -z "$PRESERVE_MERGES" &&
 625        test -z "$STRATEGY" &&
 626        test -z "$VERBOSE"
 627}
 628
 629get_saved_options () {
 630        test -d "$REWRITTEN" && PRESERVE_MERGES=t
 631        test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
 632        test -f "$DOTEST"/verbose && VERBOSE=t
 633        test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
 634}
 635
 636# Rearrange the todo list that has both "pick sha1 msg" and
 637# "pick sha1 fixup!/squash! msg" appears in it so that the latter
 638# comes immediately after the former, and change "pick" to
 639# "fixup"/"squash".
 640rearrange_squash () {
 641        sed -n -e 's/^pick \([0-9a-f]*\) \(squash\)! /\1 \2 /p' \
 642                -e 's/^pick \([0-9a-f]*\) \(fixup\)! /\1 \2 /p' \
 643                "$1" >"$1.sq"
 644        test -s "$1.sq" || return
 645
 646        used=
 647        while read pick sha1 message
 648        do
 649                case " $used" in
 650                *" $sha1 "*) continue ;;
 651                esac
 652                echo "$pick $sha1 $message"
 653                while read squash action msg
 654                do
 655                        case "$message" in
 656                        "$msg"*)
 657                                echo "$action $squash $action! $msg"
 658                                used="$used$squash "
 659                                ;;
 660                        esac
 661                done <"$1.sq"
 662        done >"$1.rearranged" <"$1"
 663        cat "$1.rearranged" >"$1"
 664        rm -f "$1.sq" "$1.rearranged"
 665}
 666
 667LF='
 668'
 669parse_onto () {
 670        case "$1" in
 671        *...*)
 672                if      left=${1%...*} right=${1#*...} &&
 673                        onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 674                then
 675                        case "$onto" in
 676                        ?*"$LF"?* | '')
 677                                exit 1 ;;
 678                        esac
 679                        echo "$onto"
 680                        exit 0
 681                fi
 682        esac
 683        git rev-parse --verify "$1^0"
 684}
 685
 686while test $# != 0
 687do
 688        case "$1" in
 689        --no-verify)
 690                OK_TO_SKIP_PRE_REBASE=yes
 691                ;;
 692        --verify)
 693                ;;
 694        --continue)
 695                is_standalone "$@" || usage
 696                get_saved_options
 697                comment_for_reflog continue
 698
 699                test -d "$DOTEST" || die "No interactive rebase running"
 700
 701                # Sanity check
 702                git rev-parse --verify HEAD >/dev/null ||
 703                        die "Cannot read HEAD"
 704                git update-index --ignore-submodules --refresh &&
 705                        git diff-files --quiet --ignore-submodules ||
 706                        die "Working tree is dirty"
 707
 708                # do we have anything to commit?
 709                if git diff-index --cached --quiet --ignore-submodules HEAD --
 710                then
 711                        : Nothing to commit -- skip this
 712                else
 713                        . "$AUTHOR_SCRIPT" ||
 714                                die "Cannot find the author identity"
 715                        amend=
 716                        if test -f "$AMEND"
 717                        then
 718                                amend=$(git rev-parse --verify HEAD)
 719                                test "$amend" = $(cat "$AMEND") ||
 720                                die "\
 721You have uncommitted changes in your working tree. Please, commit them
 722first and then run 'git rebase --continue' again."
 723                                git reset --soft HEAD^ ||
 724                                die "Cannot rewind the HEAD"
 725                        fi
 726                        do_with_author git commit --no-verify -F "$MSG" -e || {
 727                                test -n "$amend" && git reset --soft $amend
 728                                die "Could not commit staged changes."
 729                        }
 730                fi
 731
 732                record_in_rewritten "$(cat "$DOTEST"/stopped-sha)"
 733
 734                require_clean_work_tree
 735                do_rest
 736                ;;
 737        --abort)
 738                is_standalone "$@" || usage
 739                get_saved_options
 740                comment_for_reflog abort
 741
 742                git rerere clear
 743                test -d "$DOTEST" || die "No interactive rebase running"
 744
 745                HEADNAME=$(cat "$DOTEST"/head-name)
 746                HEAD=$(cat "$DOTEST"/head)
 747                case $HEADNAME in
 748                refs/*)
 749                        git symbolic-ref HEAD $HEADNAME
 750                        ;;
 751                esac &&
 752                output git reset --hard $HEAD &&
 753                rm -rf "$DOTEST"
 754                exit
 755                ;;
 756        --skip)
 757                is_standalone "$@" || usage
 758                get_saved_options
 759                comment_for_reflog skip
 760
 761                git rerere clear
 762                test -d "$DOTEST" || die "No interactive rebase running"
 763
 764                output git reset --hard && do_rest
 765                ;;
 766        -s)
 767                case "$#,$1" in
 768                *,*=*)
 769                        STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
 770                1,*)
 771                        usage ;;
 772                *)
 773                        STRATEGY="-s $2"
 774                        shift ;;
 775                esac
 776                ;;
 777        -m)
 778                # we use merge anyway
 779                ;;
 780        -v)
 781                VERBOSE=t
 782                ;;
 783        -p)
 784                PRESERVE_MERGES=t
 785                ;;
 786        -i)
 787                # yeah, we know
 788                ;;
 789        --no-ff)
 790                NEVER_FF=t
 791                ;;
 792        --root)
 793                REBASE_ROOT=t
 794                ;;
 795        --autosquash)
 796                AUTOSQUASH=t
 797                ;;
 798        --onto)
 799                shift
 800                ONTO=$(parse_onto "$1") ||
 801                        die "Does not point to a valid commit: $1"
 802                ;;
 803        --)
 804                shift
 805                test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
 806                test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
 807                test -d "$DOTEST" &&
 808                        die "Interactive rebase already started"
 809
 810                git var GIT_COMMITTER_IDENT >/dev/null ||
 811                        die "You need to set your committer info first"
 812
 813                if test -z "$REBASE_ROOT"
 814                then
 815                        UPSTREAM_ARG="$1"
 816                        UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
 817                        test -z "$ONTO" && ONTO=$UPSTREAM
 818                        shift
 819                else
 820                        UPSTREAM=
 821                        UPSTREAM_ARG=--root
 822                        test -z "$ONTO" &&
 823                                die "You must specify --onto when using --root"
 824                fi
 825                run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
 826
 827                comment_for_reflog start
 828
 829                require_clean_work_tree
 830
 831                if test ! -z "$1"
 832                then
 833                        output git checkout "$1" ||
 834                                die "Could not checkout $1"
 835                fi
 836
 837                HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
 838                mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
 839
 840                : > "$DOTEST"/interactive || die "Could not mark as interactive"
 841                git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
 842                        echo "detached HEAD" > "$DOTEST"/head-name
 843
 844                echo $HEAD > "$DOTEST"/head
 845                case "$REBASE_ROOT" in
 846                '')
 847                        rm -f "$DOTEST"/rebase-root ;;
 848                *)
 849                        : >"$DOTEST"/rebase-root ;;
 850                esac
 851                echo $ONTO > "$DOTEST"/onto
 852                test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
 853                test t = "$VERBOSE" && : > "$DOTEST"/verbose
 854                if test t = "$PRESERVE_MERGES"
 855                then
 856                        if test -z "$REBASE_ROOT"
 857                        then
 858                                mkdir "$REWRITTEN" &&
 859                                for c in $(git merge-base --all $HEAD $UPSTREAM)
 860                                do
 861                                        echo $ONTO > "$REWRITTEN"/$c ||
 862                                                die "Could not init rewritten commits"
 863                                done
 864                        else
 865                                mkdir "$REWRITTEN" &&
 866                                echo $ONTO > "$REWRITTEN"/root ||
 867                                        die "Could not init rewritten commits"
 868                        fi
 869                        # No cherry-pick because our first pass is to determine
 870                        # parents to rewrite and skipping dropped commits would
 871                        # prematurely end our probe
 872                        MERGES_OPTION=
 873                        first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
 874                else
 875                        MERGES_OPTION="--no-merges --cherry-pick"
 876                fi
 877
 878                SHORTHEAD=$(git rev-parse --short $HEAD)
 879                SHORTONTO=$(git rev-parse --short $ONTO)
 880                if test -z "$REBASE_ROOT"
 881                        # this is now equivalent to ! -z "$UPSTREAM"
 882                then
 883                        SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
 884                        REVISIONS=$UPSTREAM...$HEAD
 885                        SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
 886                else
 887                        REVISIONS=$ONTO...$HEAD
 888                        SHORTREVISIONS=$SHORTHEAD
 889                fi
 890                git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
 891                        --abbrev=7 --reverse --left-right --topo-order \
 892                        $REVISIONS | \
 893                        sed -n "s/^>//p" | while read shortsha1 rest
 894                do
 895                        if test t != "$PRESERVE_MERGES"
 896                        then
 897                                echo "pick $shortsha1 $rest" >> "$TODO"
 898                        else
 899                                sha1=$(git rev-parse $shortsha1)
 900                                if test -z "$REBASE_ROOT"
 901                                then
 902                                        preserve=t
 903                                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
 904                                        do
 905                                                if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
 906                                                then
 907                                                        preserve=f
 908                                                fi
 909                                        done
 910                                else
 911                                        preserve=f
 912                                fi
 913                                if test f = "$preserve"
 914                                then
 915                                        touch "$REWRITTEN"/$sha1
 916                                        echo "pick $shortsha1 $rest" >> "$TODO"
 917                                fi
 918                        fi
 919                done
 920
 921                # Watch for commits that been dropped by --cherry-pick
 922                if test t = "$PRESERVE_MERGES"
 923                then
 924                        mkdir "$DROPPED"
 925                        # Save all non-cherry-picked changes
 926                        git rev-list $REVISIONS --left-right --cherry-pick | \
 927                                sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
 928                        # Now all commits and note which ones are missing in
 929                        # not-cherry-picks and hence being dropped
 930                        git rev-list $REVISIONS |
 931                        while read rev
 932                        do
 933                                if test -f "$REWRITTEN"/$rev -a "$(sane_grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
 934                                then
 935                                        # Use -f2 because if rev-list is telling us this commit is
 936                                        # not worthwhile, we don't want to track its multiple heads,
 937                                        # just the history of its first-parent for others that will
 938                                        # be rebasing on top of it
 939                                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
 940                                        short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
 941                                        sane_grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
 942                                        rm "$REWRITTEN"/$rev
 943                                fi
 944                        done
 945                fi
 946
 947                test -s "$TODO" || echo noop >> "$TODO"
 948                test -n "$AUTOSQUASH" && rearrange_squash "$TODO"
 949                cat >> "$TODO" << EOF
 950
 951# Rebase $SHORTREVISIONS onto $SHORTONTO
 952#
 953# Commands:
 954#  p, pick = use commit
 955#  r, reword = use commit, but edit the commit message
 956#  e, edit = use commit, but stop for amending
 957#  s, squash = use commit, but meld into previous commit
 958#  f, fixup = like "squash", but discard this commit's log message
 959#
 960# If you remove a line here THAT COMMIT WILL BE LOST.
 961# However, if you remove everything, the rebase will be aborted.
 962#
 963EOF
 964
 965                has_action "$TODO" ||
 966                        die_abort "Nothing to do"
 967
 968                cp "$TODO" "$TODO".backup
 969                git_editor "$TODO" ||
 970                        die_abort "Could not execute editor"
 971
 972                has_action "$TODO" ||
 973                        die_abort "Nothing to do"
 974
 975                test -d "$REWRITTEN" || test -n "$NEVER_FF" || skip_unnecessary_picks
 976
 977                git update-ref ORIG_HEAD $HEAD
 978                output git checkout $ONTO && do_rest
 979                ;;
 980        esac
 981        shift
 982done